import os, sys

try:
	import pyext
except:
	print "ERROR: This script must be loaded by the PD/Max pyext external"

# a function marking the low and high border of a pitch within he range of 0.0 to 1.0
def pitchBorder(Plist):
        pitemBoarders = {}
        pindex = 0
        plistHBorder = 0
        plistLBorder = 0
        for pindex in range(len(Plist)):
            plistHBorder = plistHBorder + Plist[pindex]
            if pindex == 0:
                plistLBorder = 0
            else:
                plistLBorder = plistLBorder + Plist[pindex-1]
            keyLPB = 'pLB'+str(pindex)
            pitemBoarders[keyLPB]= plistLBorder
            keyHPB = 'pHB'+str(pindex)
            pitemBoarders[keyHPB]= plistHBorder
        return pitemBoarders

# a function marking the low and high border of a sound within he range of 0.0 to 1.0
def soundBorder(Slist):
        sitemBoarders = {}
        sindex = 0
        slistHBorder = 0
        slistLBorder = 0
        for sindex in range(len(Slist)):
            slistHBorder = slistHBorder + Slist[sindex]
            if sindex == 0:
                slistLBorder = 0
            else:
                slistLBorder = slistLBorder + Slist[sindex-1]
            keyLSB = 'sLB'+str(sindex)
            sitemBoarders[keyLSB]= slistLBorder
            keyHSB = 'sHB'+str(sindex)
            sitemBoarders[keyHSB]= slistHBorder
        return sitemBoarders

# a function mapping pitch to sound by detecting overlapping areas
# the function also defines a mapping probability based on the percentage of overlap area
def pitchToSound(Plist,Slist,pitemBoarders,sitemBoarders):
        pitch_soundProb = {}
        for pindex in range(len(Plist)):
            keyLPB = 'pLB'+str(pindex)
            keyHPB = 'pHB'+str(pindex)
            pMap = []
            for sindex in range(len(Slist)):       
                keyHSB = 'sHB'+str(sindex)
                keyLSB = 'sLB'+str(sindex)
                sMap =[]
                if (pitemBoarders[keyLPB]<=sitemBoarders[keyLSB])and(pitemBoarders[keyHPB]>=sitemBoarders[keyHSB]):
                    prob = Plist[pindex] - ((sitemBoarders[keyLSB]-pitemBoarders[keyLPB])+(pitemBoarders[keyHPB]-sitemBoarders[keyHSB]))
                    print 'pitch'+str(pindex)+' map to sound'+str(sindex)+' prob of '+str(prob/Plist[pindex])
                    sMap.insert(0, sindex)
                    sMap.insert(1, round((prob/Plist[pindex]),2))
                elif (pitemBoarders[keyLPB]>=sitemBoarders[keyLSB])and(pitemBoarders[keyHPB]<=sitemBoarders[keyHSB]):
                    prob = Plist[pindex]
                    print 'pitch'+str(pindex)+' map to sound'+str(sindex)+' prob of '+str(prob/Plist[pindex])
                    sMap.insert(0, sindex)
                    sMap.insert(1, round((prob/Plist[pindex]),2))
                elif (pitemBoarders[keyLPB]<sitemBoarders[keyHSB])and(pitemBoarders[keyLPB]>sitemBoarders[keyLSB]):
                    prob = sitemBoarders[keyHSB]-pitemBoarders[keyLPB]
                    print 'pitch'+str(pindex)+' map to sound'+str(sindex)+' prob of '+str(prob/Plist[pindex])
                    sMap.insert(0, sindex)
                    sMap.insert(1, round((prob/Plist[pindex]),2))
                elif (pitemBoarders[keyHPB]<sitemBoarders[keyHSB])and(pitemBoarders[keyHPB]>sitemBoarders[keyLSB]):
                    prob = pitemBoarders[keyHPB]-sitemBoarders[keyLSB]
                    print 'pitch'+str(pindex)+' map to sound'+str(sindex)+' prob of '+str(prob/Plist[pindex])
                    sMap.insert(0, sindex)
                    sMap.insert(1, round((prob/Plist[pindex]),2))
                else:
                    continue
                pMap.append(sMap)
            keyProb ='p'+str(pindex)
            pitch_soundProb[keyProb] = pMap
        return pitch_soundProb
        

class pitchSoundMax(pyext._class):
    _inlets=3
    _outlets=2

    def __init__(self):
        self.Slist = []
        self.Plist = []
        self.pitemBoarders = {}
        self.sitemBoarders = {}
        self.pitch_soundProb = {}

    def list_1(self,*st):
        self.Plist = list(st)
        self.pitemBoarders = pitchBorder(self.Plist)
        #pindex = 0
        #sindex = 0
        #plistHBorder = 0
        #slistHBorder = 0
        #plistLBorder = 0
        #slistLBorder = 0
        #pitemBoarders = {}
        #sitemBoarders = {}

        #self._outlet(1,self.pitemBoarders)
        print self.pitemBoarders

    def list_2(self,*st):
        self.Slist = list(st)
        self.sitemBoarders = soundBorder(self.Slist)
        #self._outlet(1,self.sitemBoarders)
        print self.sitemBoarders

    def bang_1(self):
        self.pitch_soundProb = pitchToSound(self.Plist,self.Slist,self.pitemBoarders,self.sitemBoarders)
        print self.pitch_soundProb

# a function comparing a pitch to sounds probability list with a random number
# and outputting the matching probability
    def list_3(self,*st):
        inlist = list(st)
        print inlist
        f = inlist[0]
        keyProb = 'p'+str((f)%12)
        lwb = 0
        print self.pitch_soundProb[keyProb]
        sProb = self.pitch_soundProb[keyProb]
        for sitem in sProb:
                if inlist[1] > lwb and inlist[1] <= (sitem[1] + lwb):
                        print sitem[0]
                        self._outlet(1,sitem[0])
                else:
                        continue
                lwb = lwb + sitem[1]
                
                
                                     

        

        

        
    
                    
        
                                    
    

    

			
		
			
		
		

		
		
